let formDataNodeOnMap = new FormData();

const setFormDataNodeOnMap = (key, value) => formDataNodeOnMap.set(key, value);

const dragElement = (elmnt) => {
  setInitialFormData();

  let pos1 = 0, pos2 = 0, pos3 = 0, pos4 = 0;
  elmnt.onmousedown = dragMouseDown;

  function dragMouseDown(e) {
    e = e || window.event;
    e.preventDefault();
    // get the mouse cursor position at startup:
    pos3 = e.clientX;
    pos4 = e.clientY;
    if (elmnt.offsetLeft - pos1 >= 0 && elmnt.offsetTop - pos2 >= 0) {
      document.onmouseup = closeDragElement;
      // call a function whenever the cursor moves:
      document.onmousemove = elementDrag;
    };
  }

  function elementDrag(e) {
    e = e || window.event;
    e.preventDefault();
    // calculate the new cursor position:
    pos1 = pos3 - e.clientX;
    pos2 = pos4 - e.clientY;
    pos3 = e.clientX;
    pos4 = e.clientY;
    // set the element's new position:
    if (elmnt.offsetTop - pos2 <= 10) {
      elmnt.style.top = "5px";
    } else if (elmnt.offsetTop - pos2 >= canvas.height - 15) {
      elmnt.style.top = (canvas.height - 15) + "px";
    } else {
      elmnt.style.top = (elmnt.offsetTop - pos2) + "px";
    }

    if (elmnt.offsetLeft - pos1 <= 10) {
      elmnt.style.left = "5px";
    } else if (elmnt.offsetLeft - pos1 >= canvas.width - 20) {
      elmnt.style.left = (canvas.width - 20) + "px";
    } else {
      elmnt.style.left = (elmnt.offsetLeft - pos1) + "px";
    }
  }

  function closeDragElement() {
    // stop moving when mouse button is released:
    setFormDataNodeOnMap('id', (mapSelectedNode.foreign_key_id || mapSelectedNode.id).toString());
    setFormDataNodeOnMap('authenticity_token', window._rails_csrf_token);
    setFormDataNodeOnMap('_method', 'put');
    setFormDataNodeOnMap('commit', 'Save Changes');
    setFormDataNodeOnMap('node[map_x]', getXPosRatio(elmnt.offsetLeft));
    setFormDataNodeOnMap('node[map_y]', getYPosRatio(elmnt.offsetTop));
    document.onmouseup = null;
    document.onmousemove = null;
  }

  const getXPosRatio = posInPx => parseFloat((posInPx/canvas.width).toFixed(6));
  const getYPosRatio = posInPx => parseFloat((posInPx/canvas.height).toFixed(6));
}

const saveMapChanges = () => {
  setFormDataNodeOnMap('node[map_visible]', document.getElementById('showOnMapCheckBox').checked ? 1 : 0);
  const urlParams = new URLSearchParams();
  for (let [name, value] of formDataNodeOnMap) {
    urlParams.append(name, value);
  }
  const options = {
    method: 'POST',
    body: urlParams,
  }
  const successCb = response => {
    const msgHtml = response.status >= 200 && response.status < 400
      ?
      `
        <span id="rails_flash">
          <div class="flash flash_notice" id="flash_notice">Map coordinates updated</div>
        </span>
      `
      :
      `
        <span id="rails_flash">
          <div class="flash flash_error" id="flash_notice">Map coordinates fails to update</div>
        </span>
      `
      ;

    jQuery(function($) {
      if ($('#rails_flash')){
        $('#rails_flash').hide();
      }
      $('#bd .full_page_title').after(msgHtml);
      $('#rails_flash').hide();
      $('#rails_flash').fadeIn('fast');
      $(window).scrollTop(0);
    });
  }
  fetch(`/aspera/console/${mapSelectedNode.type === 'managed' ? 'nodes' : 'partner_nodes'}/${mapSelectedNode.type === 'managed' ? mapSelectedNode.id.toString() : mapSelectedNode.foreign_key_id.toString()}/update_map`, options)
  .then(successCb)
  .catch(err => console.log(err))
}

const setInitialFormData = () => {
  setFormDataNodeOnMap('id', (mapSelectedNode.foreign_key_id || mapSelectedNode.id).toString());
  setFormDataNodeOnMap('node[map_visible]', mapSelectedNode.map_visible ? 1 : 0);
  setFormDataNodeOnMap('authenticity_token', window._rails_csrf_token);
  setFormDataNodeOnMap('_method', 'put');
  setFormDataNodeOnMap('commit', 'Save Changes');
  setFormDataNodeOnMap('node[map_x]', mapSelectedNode.map_x);
  setFormDataNodeOnMap('node[map_y]', mapSelectedNode.map_y);
}
